import os
from PyQt5 import uic
from PyQt5.QtWidgets import QDialog

from qgis.core import QgsSettings

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'remote_connection.ui'))


class RemoteConnectionDlg(QDialog, FORM_CLASS):
    def __init__(self, parent=None):
        QDialog.__init__(self, parent)
        self.setupUi(self)

        s = QgsSettings()

        self.host_edit.setText(s.value("PAGGF/remote_host", "localhost"))
        self.port_edit.setText(s.value("PAGGF/remote_port", "5432"))
        self.user_edit.setText(s.value("PAGGF/remote_user", "paggf"))
        self.button_box.accepted.connect(self.on_accepted)

    def conn_string(self):
        return "host={} port={} dbname=paggf user={} password={}".format(
            self.host_edit.text(),
            self.port_edit.text(),
            self.user_edit.text(),
            self.pwd_edit.text())

    def on_accepted(self):
        s = QgsSettings()
        s.setValue("PAGGF/remote_host", self.host_edit.text())
        s.setValue("PAGGF/remote_port", self.port_edit.text())
        s.setValue("PAGGF/remote_user", self.user_edit.text())
